<?php

namespace FiloBlu\Flow\Model\Parser;

/**
 * Class Csv
 * @package FiloBlu\Flow\Model\Parser
 */
class Csv extends AbstractParser
{
    

    /**
     * @param $resource string absolute path of the the csv file
     * @throws \Exception
     */
    public function process($resource)
    {
        $count = 0;

        if (false === ($handle = @fopen($resource, 'r'))) {
            throw new \Exception("Unable to open {$resource}");
        }

        while (($data = fgetcsv($handle, 0, $this->separator, $this->delimiter)) !== false) {

            $count++;

            if ($count === 1) {
                foreach ($data as $header) {
                    $this->header[] = strtolower(trim($header));
                }
            }

            if ($count <= $this->linesToSkip) {
                continue;
            }

            try {
                array_walk($data, function (&$value, $key){$value = trim($value);});
                $this->parse($data);
            } catch (\Exception $e) {
                throw new \Exception($e->getMessage() . ' at row' . $count);
            }

        }

        fclose($handle);

        $channel = $this->getChannel();

        if (method_exists($channel, 'commitData') && !is_null($channel)) {
            $channel->commitData();
        }

    }

}
